<template>
    <div>
        <UsersFilter />
        <Pagination :page="page" :last_page="lastPage" />
        <UserItem v-for="user in items" :user-data="user" :key="user.id" />
    </div>
</template>

<script>
import { mapActions, mapState } from "vuex";
import UserItem from "@/components/Admin/UserItem";
import Pagination from "@/components/Pagination";
import UsersFilter from "@/components/Admin/UsersFilter";
import snackbar from "@/utils/snackbar";

export default {
    name: "UserList",
    components: { UsersFilter, Pagination, UserItem },
    methods: {
        ...mapActions("admin", ["getUserList"]),
        async getData(params) {
            try {
                await this.getUserList(params);
            } catch (e) {
                snackbar(e);
            }
        },
    },
    computed: {
        ...mapState("admin", ["serverData"]),
        items() {
            return this.serverData?.data || [];
        },
        page() {
            return this.serverData?.current_page || 1;
        },
        lastPage() {
            return this.serverData?.last_page || 1;
        },
    },
    watch: {
        "$route.query": {
            immediate: true,
            handler(params) {
                this.getData(params);
            },
        },
    },
};
</script>

<style scoped></style>
